function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import * as types from './types';

function collection(list, action) {
  if (list === void 0) {
    list = [];
  }

  var payload = action.payload,
      append = action.append;

  switch (action.type) {
    case types.INIIALIZE:
      return append ? [].concat(list, payload) : payload;

    case types.CHILD_ADDED:
      return list.findIndex(function (d) {
        return d.id === payload.id;
      }) === -1 ? [].concat(list, [payload]) : [].concat(list);

    case types.CHILD_CHANGED:
      return list.map(function (child) {
        return payload.id === child.id ? payload : child;
      });

    case types.CHILD_REMOVED:
      return list.filter(function (child) {
        return payload.id !== child.id;
      });
  }
}

export default function collections(state, action) {
  var _extends2, _extends3;

  if (state === void 0) {
    state = {};
  }

  var location = action.location;

  switch (action.type) {
    case types.INIIALIZE:
      return _extends({}, state, (_extends2 = {}, _extends2[location] = collection(state[action.location], action), _extends2));

    case types.CHILD_ADDED:
    case types.CHILD_CHANGED:
    case types.CHILD_REMOVED:
      return _extends({}, state, (_extends3 = {}, _extends3[location] = collection(state[action.location], action), _extends3));

    case types.DESTROY:
      var _state = state,
          omitData = _state[location],
          rest = _objectWithoutPropertiesLoose(_state, [location].map(_toPropertyKey));

      return _extends({}, rest);

    default:
      return state;
  }
}