"use strict";

exports.__esModule = true;
exports["default"] = exports.isInitialised = exports.getAllDocs = exports.getDoc = exports.getAllPaths = exports.getPath = exports.getAllInitializations = exports.getAllCols = exports.getCol = exports.hasError = exports.isLoading = exports.getAllLists = exports.getList = exports.unwatchAllPaths = exports.destroyPath = exports.unwatchPath = exports.watchPath = exports.unwatchAllLists = exports.destroyList = exports.unwatchList = exports.watchList = exports.unwatchAllDocs = exports.destroyDoc = exports.unwatchDoc = exports.watchDoc = exports.unwatchAllCols = exports.destroyCol = exports.unwatchCol = exports.watchCol = exports.authError = exports.authStateChanged = exports.watchAuth = exports.clearAllLoadings = exports.clearLoading = exports.logLoading = exports.clearAllErrors = exports.clearError = exports.logError = exports.clearMessage = exports.initMessaging = exports.unsubscribeConnection = exports.initConnection = exports.pathsReducer = exports.messagingReducer = exports.loadingsReducer = exports.listsReducer = exports.initializationReducer = exports.errorsReducer = exports.docsReducer = exports.connectionReducer = exports.collectionsReducer = exports.authReducer = exports.clearInitialization = void 0;

var _reducer = _interopRequireDefault(require("./store/auth/reducer"));

exports.authReducer = _reducer["default"];

var _reducer2 = _interopRequireDefault(require("./store/collections/reducer"));

exports.collectionsReducer = _reducer2["default"];

var _reducer3 = _interopRequireDefault(require("./store/connection/reducer"));

exports.connectionReducer = _reducer3["default"];

var _reducer4 = _interopRequireDefault(require("./store/docs/reducer"));

exports.docsReducer = _reducer4["default"];

var _reducer5 = _interopRequireDefault(require("./store/errors/reducer"));

exports.errorsReducer = _reducer5["default"];

var _reducer6 = _interopRequireDefault(require("./store/initialization/reducer"));

exports.initializationReducer = _reducer6["default"];

var _reducer7 = _interopRequireDefault(require("./store/lists/reducer"));

exports.listsReducer = _reducer7["default"];

var _reducer8 = _interopRequireDefault(require("./store/loadings/reducer"));

exports.loadingsReducer = _reducer8["default"];

var _reducer9 = _interopRequireDefault(require("./store/messaging/reducer"));

exports.messagingReducer = _reducer9["default"];

var _reducer10 = _interopRequireDefault(require("./store/paths/reducer"));

exports.pathsReducer = _reducer10["default"];

var _actions = require("./store/initialization/actions");

exports.clearInitialization = _actions.clearInitialization;

var _actions2 = require("./store/connection/actions");

exports.initConnection = _actions2.initConnection;
exports.unsubscribeConnection = _actions2.unsubscribeConnection;

var _actions3 = require("./store/messaging/actions");

exports.initMessaging = _actions3.initMessaging;
exports.clearMessage = _actions3.clearMessage;

var _actions4 = require("./store/errors/actions");

exports.logError = _actions4.logError;
exports.clearError = _actions4.clearError;
exports.clearAllErrors = _actions4.clearAllErrors;

var _actions5 = require("./store/loadings/actions");

exports.logLoading = _actions5.logLoading;
exports.clearLoading = _actions5.clearLoading;
exports.clearAllLoadings = _actions5.clearAllLoadings;

var _actions6 = require("./store/auth/actions");

exports.watchAuth = _actions6.watchAuth;
exports.authStateChanged = _actions6.authStateChanged;
exports.authError = _actions6.authError;

var _actions7 = require("./store/collections/actions");

exports.watchCol = _actions7.watchCol;
exports.unwatchCol = _actions7.unwatchCol;
exports.destroyCol = _actions7.destroyCol;
exports.unwatchAllCols = _actions7.unwatchAllCols;

var _actions8 = require("./store/docs/actions");

exports.watchDoc = _actions8.watchDoc;
exports.unwatchDoc = _actions8.unwatchDoc;
exports.destroyDoc = _actions8.destroyDoc;
exports.unwatchAllDocs = _actions8.unwatchAllDocs;

var _actions9 = require("./store/lists/actions");

exports.watchList = _actions9.watchList;
exports.unwatchList = _actions9.unwatchList;
exports.destroyList = _actions9.destroyList;
exports.unwatchAllLists = _actions9.unwatchAllLists;

var _actions10 = require("./store/paths/actions");

exports.watchPath = _actions10.watchPath;
exports.unwatchPath = _actions10.unwatchPath;
exports.destroyPath = _actions10.destroyPath;
exports.unwatchAllPaths = _actions10.unwatchAllPaths;

var _selectors = require("./store/lists/selectors");

exports.getList = _selectors.getList;
exports.getAllLists = _selectors.getAllLists;

var _selectors2 = require("./store/loadings/selectors");

exports.isLoading = _selectors2.isLoading;

var _selectors3 = require("./store/errors/selectors");

exports.hasError = _selectors3.hasError;

var _selectors4 = require("./store/collections/selectors");

exports.getCol = _selectors4.getCol;
exports.getAllCols = _selectors4.getAllCols;
exports.getAllInitializations = _selectors4.getAllInitializations;

var _selectors5 = require("./store/paths/selectors");

exports.getPath = _selectors5.getPath;
exports.getAllPaths = _selectors5.getAllPaths;

var _selectors6 = require("./store/docs/selectors");

exports.getDoc = _selectors6.getDoc;
exports.getAllDocs = _selectors6.getAllDocs;

var _selectors7 = require("./store/initialization/selectors");

exports.isInitialised = _selectors7.isInitialised;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var firekitReducers = {
  auth: _reducer["default"],
  collections: _reducer2["default"],
  connection: _reducer3["default"],
  docs: _reducer4["default"],
  errors: _reducer5["default"],
  initialization: _reducer6["default"],
  lists: _reducer7["default"],
  loadings: _reducer8["default"],
  messaging: _reducer9["default"],
  paths: _reducer10["default"]
};
var _default = firekitReducers;
exports["default"] = _default;