"use strict";

exports.__esModule = true;
exports["default"] = initialization;

var collectionsTypes = _interopRequireWildcard(require("../collections/types"));

var docsTypes = _interopRequireWildcard(require("../docs/types"));

var listsTypes = _interopRequireWildcard(require("../lists/types"));

var pathsTypes = _interopRequireWildcard(require("../paths/types"));

var types = _interopRequireWildcard(require("./types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function locations(state, action) {
  var _extends2;

  if (state === void 0) {
    state = [];
  }

  var location = action.location,
      locationValue = action.locationValue;

  switch (action.type) {
    case listsTypes.INIIALIZE:
    case collectionsTypes.INIIALIZE:
    case pathsTypes.VALUE_CHANGED:
    case docsTypes.VALUE_CHANGED:
      return _extends({}, state, (_extends2 = {}, _extends2[location] = locationValue, _extends2));
  }
}

function initialization(state, action) {
  var _extends3;

  if (state === void 0) {
    state = {};
  }

  var path = action.path;

  switch (action.type) {
    case listsTypes.INIIALIZE:
    case collectionsTypes.INIIALIZE:
    case pathsTypes.VALUE_CHANGED:
    case docsTypes.VALUE_CHANGED:
      return _extends({}, state, (_extends3 = {}, _extends3[path] = locations(state[path], action), _extends3));

    case types.CLEAR_INITIALIZATION:
      return {};

    case listsTypes.DESTROY:
    case listsTypes.UNWATCH:
    case collectionsTypes.DESTROY:
    case collectionsTypes.UNWATCH:
    case pathsTypes.DESTROY:
    case pathsTypes.UNWATCH:
    case docsTypes.DESTROY:
    case docsTypes.UNWATCH:
      var _state = state,
          omit = _state[path],
          rest = _objectWithoutPropertiesLoose(_state, [path].map(_toPropertyKey));

      return _extends({}, rest);

    default:
      return state;
  }
}

module.exports = exports.default;